--- code.l.orig 2012-07-12 22:37:56.000000000 +0200
+++ code.l	2012-07-13 14:00:42.000000000 +0200
@@ -1302,6 +1302,10 @@
   ClassDef *ccd=0;
   QCString locScope=g_classScope;
   QCString locFunc=removeRedundantWhiteSpace(funcName);
+  QCString funcScope;
+  QCString funcWithScope=locFunc;
+  QCString funcWithFullScope=locFunc;
+  QCString fullScope=locScope;
   //fprintf(stdout,"*** locScope=%s locFunc=%s\n",locScope.data(),locFunc.data());
   int len=2;
   int i=locFunc.findRev("::");
@@ -1323,14 +1327,7 @@
   if (i==-1) i=locFunc.findRev("\\"),len=1; // for PHP
   if (i>0)
   {
-    if (locScope.isEmpty())
-    {
-      locScope=locFunc.left(i);
-    }
-    else
-    {
-      locScope+="::"+locFunc.left(i);
-    }
+    funcScope=locFunc.left(i);
     locFunc=locFunc.right(locFunc.length()-i-len).stripWhiteSpace();
     int ts=locScope.find('<'); // start of template
     int te=locScope.findRev('>'); // end of template
@@ -1340,9 +1337,28 @@
       // remove template from scope
       locScope=locScope.left(ts)+locScope.right(locScope.length()-te-1);
     }
+    ts=funcScope.find('<'); // start of template
+    te=funcScope.findRev('>'); // end of template
+    //printf("ts=%d te=%d\n",ts,te);
+    if (ts!=-1 && te!=-1 && te>ts)
+    {
+      // remove template from scope
+      funcScope=funcScope.left(ts)+funcScope.right(funcScope.length()-te-1);
+    }
+    if (!funcScope.isEmpty())
+    {
+      funcWithScope = funcScope+"::"+locFunc;
+      if (!locScope.isEmpty())
+      {
+        fullScope=locScope+"::"+funcScope;
+      }
+    }
+    if (!locScope.isEmpty())
+    {
+      funcWithFullScope = locScope+"::"+funcWithScope;
+    }
   }
-  //printf("generateFunctionLink(%s) classScope=`%s'\n",locFunc.data(),locScope.data());
-  if (!locScope.isEmpty() && (ccd=g_codeClassSDict->find(locScope)))
+  if (!fullScope.isEmpty() && (ccd=g_codeClassSDict->find(fullScope)))
   {
     //printf("using classScope %s\n",g_classScope.data());
     if (ccd->baseClasses())
@@ -1357,7 +1373,22 @@
       }
     }
   }
-  if (!getLink(locScope,locFunc,ol,funcName))
+  if (!locScope.isEmpty() && (ccd=g_codeClassSDict->find(locScope)))
+  {
+    //printf("using classScope %s\n",g_classScope.data());
+    if (ccd->baseClasses())
+    {
+      BaseClassListIterator bcli(*ccd->baseClasses());
+      for ( ; bcli.current() ; ++bcli)
+      {
+	if (getLink(bcli.current()->classDef->name(),funcWithScope,ol,funcName)) 
+	{
+	  goto exit;
+	}
+      }
+    }
+  }
+  if (!getLink(locScope,funcWithScope,ol,funcName))
   {
     generateClassOrGlobalLink(ol,funcName);
   }
